local g=love.graphics
local k=love.keyboard.isDown

local function CheckCollision(ax1,ay1,aw,ah, bx1,by1,bw,bh)
  local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
  return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end 

local function oo(x,y)
   if  CheckCollision(x, y, l.w, l.h          ,ll.x, ll.y, ll.w, ll.h) then
      while CheckCollision(x, y, l.w, l.h     ,ll.x, ll.y, ll.w, ll.h) do
		 
		 	if l.direction == 'left'  then  x = x - 1 end
		 	if l.direction == 'right' then  x = x + 1 end
		 	if l.direction == 'up'    then	y = y - 1 end
		 	if l.direction == 'down'  then  y = y + 1 end
	 	end		
   else
      l.x = x
      l.y = y
   end

end



function love.load()
   l={}
   l.x=100
   l.y=100
   l.w=50
   l.h=50
   l.direction = 'right'
   run=700
   
   
   ll={}
   ll.x=400
   ll.y=200
   ll.w=150
   ll.h=100
   
end

function love.update(dt)
	--                                             X              Y
	if k("d") then l.direction = 'right'; oo( (l.x + run * dt),  (l.y) ) end
	if k("a") then l.direction = 'left' ; oo( (l.x - run * dt),  (l.y) ) end
	--										    X           Y
	if k("w") then l.direction = 'up'   ; oo( (l.x),  (l.y - run * dt) ) end
	if k("s") then l.direction = 'down' ; oo( (l.x),  (l.y + run * dt) ) end   
end


function love.draw()
   g.setColor(255,255,255,255)
   g.rectangle('line',l.x, l.y, l.w, l.h)  
   g.rectangle('line',ll.x, ll.y, ll.w, ll.h)      
end